﻿/// <reference path="/resources/JQuery/jquery-1.7-vsdoc.js" />

function proget_editvariables(o) {
    /// <param name="o" value="{tblId:'',varTxtId:'',varOptId:'',addVarId:'',saveId:'',noVarsId:'',vars:object}"/>

    var deleteRow = function () {
        $(this).parents('tr').remove();

        if ($('#' + o.tblId).find('tr').length == 2) {
            $('#' + o.noVarsId).show();
        }

        return false;
    };

    var varIndex = 0;

    var getDeleteCell = function () {
        /// <returns type="jQuery"/>

        var deleteRowLink = $('<a href="#delete" class="small-delete-button"></a>').attr('id', 'lnkDel_' + varIndex++);
        var deleteCell = $('<td class="del-column"/>').append(deleteRowLink);
        $(deleteRowLink).click(deleteRow);

        return deleteCell;
    }

    var getCheckBox = function (isChecked) {
        /// <param name="isChecked" type="Boolean"/>
        /// <returns type="jQuery"/>

        var checkBox = $('<input type="checkbox"/>');
        if (isChecked)
            checkBox.attr('checked', 'checked');

        return checkBox;
    };

    for (var varName in o.vars) {
        var keyCell = $('<td class="name-cell"/>').append($('<input type="text"/>').val(varName));
        var valueInput = $('<input type="text"/>').val(o.vars[varName].value);
        var valueCell = $('<td class="value-cell"/>').append(valueInput);

        var row = $('<tr class="var-row"/>');
        row.append(keyCell);
        row.append(valueCell);
        row.append($('<td class="ps-column"></td>').append(getCheckBox(o.vars[varName].ps)));
        row.append($('<td class="cfg-column"></td>').append(getCheckBox(o.vars[varName].cfg)));
        row.append(getDeleteCell());
        row.insertBefore($('#' + o.tblId).find('tr').last());
    }

    if ($('#' + o.tblId).find('tr').length == 2) {
        $('#' + o.noVarsId).show();
    } else {
        $('#' + o.noVarsId).hide();
    }

    $('#' + o.addVarId).click(function () {
        $('#' + o.noVarsId).hide();
        var row = $('<tr class="var-row"><td class="name-cell"><input type="text"/></td><td class="value-cell"><input type="text"/></td><td class="ps-column"><input type="checkbox"/></td><td class="cfg-column"><input type="checkbox"/></td></tr>');
        row.append(getDeleteCell());
        row.insertBefore($('#' + o.tblId).find('tr').last());
        return false;
    });

    $('#' + o.saveId).click(function () {
        var values = '';
        var options = '';
        $('#' + o.tblId).find('tr.var-row').each(function () {
            var key = $(this).find('td.name-cell input').val();
            key = $.trim(key);
            if (key) {
                values += encodeURIComponent(key) + '=' + encodeURIComponent($(this).find('td.value-cell input').val()) + '&';
                options += encodeURIComponent(key) + '=' + ($(this).find('td.ps-column input:checked').length > 0 ? 'Y' : 'N') + ($(this).find('td.cfg-column input:checked').length > 0 ? 'Y' : 'N') + '&';
            }
        });

        if (values) {
            $('#' + o.varTxtId).val(values.slice(0, values.length - 1));
            $('#' + o.varOptId).val(options.slice(0, options.length - 1));
        } else {
            $('#' + o.varTxtId).val('');
            $('#' + o.varOptId).val('');
        }
    });
}